/* Copyright (c) 2002-2008, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT_MVAPICH in the top level MPICH directory.
 *
 */

#ifndef MPID_CM_USER_H
#define MPID_CM_USER_H

#include <infiniband/verbs.h>

void odu_enable_qp(int peer, struct ibv_qp * qp);
    
void cm_process_queue(int peer_rank);

static inline void odu_test_new_connection()
{
    int i;  
    if (viadev.cm_new_connection == 0)
        return; 
    /* Note: to avoid race condition, must first put down flag, then process
     * pending sends*/
    viadev.cm_new_connection = 0; 
    
    for (i=0; i<viadev.np; i++)
    {
        if (i==viadev.me)
            continue;
        if (viadev.pending_req_head[i] != NULL 
          && MPICM_IB_RC_PT2PT == cm_conn_state[i]) {
          cm_process_queue(i);    
        }       
    }
}


#endif
